#ifndef _MYGDIPLUSH_H_INCLUDED_
#define _MYGDIPLUSH_H_INCLUDED_

// 
// GDI+ helper file v1.0
// 
// Written by Zoltan Csizmadia
// 

// GDIPLUS_NO_AUTO_INIT:
// GDI+ won't be initialized at program startup, 
// you have to create GdiPlus::GdiPlusInitialize object to 
// initialize GDI+ ( GDI+ will be uninitialized, when destructor
// is called.
//#define GDIPLUS_NO_AUTO_INIT

// GDIPLUS_USE_GDIPLUS_MEM:
// GdipAlloc and GdipFree is used for memory operations
// In this case _Crt functions cannot be used to detect 
// memory leaks
//#define GDIPLUS_USE_GDIPLUS_MEM

// GDIPLUS_NO_AUTO_NAMESPACE:
// Gdiplus namespace wont' be defined as a used namespace
// In this case you have to use Gdiplus:: prefix
//#define GDIPLUS_NO_AUTO_NAMESPACE
 

// Fix for STL iterator problem
#define iterator _iterator
#define list _list
#define map _map

#define _GDIPLUSBASE_H

 
//===========================================================================
// Summary:
//      To use a GdiplusBase object, just call the constructor.
//      Gdiplus Base
//===========================================================================
	 
// zhj
#ifndef ULONG_PTR
#define ULONG_PTR DWORD
#endif
// zhj
#include <Gdiplus.h> 
// zhj
#ifndef _SafeDeletePtr
#define _SafeDeletePtr(ptr)		if(ptr!=NULL) {delete ptr; ptr = NULL;}
#endif
#ifndef _SafeDeletePtrArr
#define _SafeDeletePtrArr(ptr)	if ((ptr) != NULL) { delete [](ptr); (ptr) = NULL; }
#endif
#ifndef _SafeDeletePtrArrBySize
#define _SafeDeletePtrArrBySize(size,ptr) if(size != 0) {delete []ptr; ptr = NULL; size = 0;}
#endif
#include "FOPGDIPlusHelper.h"
// zhj

#ifdef _DEBUG
#undef new
#endif

#pragma comment (lib, "Gdiplus.lib")

namespace Gdiplus
{
 
//===========================================================================
// Summary:
//      To use a GdiPlusInitialize object, just call the constructor.
//      Gdi Plus Initialize
//===========================================================================

    class GdiPlusInitialize
    {
    public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Gdi Plus Initialize, Constructs a GdiPlusInitialize object.
	//		Returns A  value (Object).
        GdiPlusInitialize()
        {
            GdiplusStartupInput Startup;
            GdiplusStartup( &m_Token, &Startup, NULL );
        }

	
	//-----------------------------------------------------------------------
	// Summary:
	// Gdi Plus Initialize, Destructor of class GdiPlusInitialize
	//		Returns A  value (Object).
        ~GdiPlusInitialize()
        {
			CFOPHokPenCache::DestoryInstance();
			CFOPHokFontCache::DestoryInstance();
			CFOPHokBrushCache::DestoryInstance();
            GdiplusShutdown( m_Token );
        }

    protected:
 
	// Token, Specify a A 32-bit signed integer.  
        ULONG_PTR m_Token;
#ifndef GDIPLUS_NO_AUTO_INIT
 
	// Initialize, This member specify GdiPlusInitialize object.  
        static GdiPlusInitialize m_Initialize;
#endif
    };
#ifndef GDIPLUS_NO_AUTO_INIT
    GdiPlusInitialize GdiPlusInitialize::m_Initialize;
#endif
}

#ifndef GDIPLUS_NO_AUTO_NAMESPACE
using namespace Gdiplus;
#endif

// STL problem
#undef iterator
#undef list
#undef map

#endif
